searchNodes=[{"type":"module","title":"CredoNaming.Check.Consistency.ModuleFilename","doc":"This check has a base priority of low and works with any version of Elixir. Explanation If a file contains a single module, its filename should match the name of the module. # preferred # lib/foo/bar.exs defmodule Foo.Bar , do : nil # lib/foo/bar/bar.exs defmodule Foo.Bar , do : nil # lib/foo/foo.exs defmodule Foo , do : nil # lib/foo.exs defmodule Foo , do : nil # lib/foo/exceptions.exs defmodule Foo.FirstException , do : nil defmodule Foo.SecondException , do : nil # NOT preferred # lib/foo.exs defmodule Bar , do : nil # lib/foo/schemas/bar.exs defmodule Foo.Bar , do : nil Check-Specific Parameters Use the following parameters to configure this check: :plugins A list of atoms for applying plugin specific naming (ex: :phoenix) This parameter defaults to [] . :excluded_paths A list of paths to exclude This parameter defaults to [] . :acronyms A list of tuples that map a module term to its path version, eg. [{&quot;MyAppGraphQL&quot;, &quot;myapp_graphql&quot;}] This parameter defaults to [] . :valid_filename_callback A function (either &amp;fun/3 or {module, fun} ) that will be called on each filename with the name of the module it defines This parameter defaults to {nil, :valid_filename?} . :apps_path The path to the apps folder in umbrella projects This parameter defaults to &quot;apps&quot; . General Parameters Like with all checks, general params can be applied. Parameters can be configured via the .credo.exs config file .","ref":"CredoNaming.Check.Consistency.ModuleFilename.html"},{"type":"function","title":"CredoNaming.Check.Consistency.ModuleFilename.root_path/2","doc":"Returns the root path of a file, with support for umbrella projects","ref":"CredoNaming.Check.Consistency.ModuleFilename.html#root_path/2"},{"type":"function","title":"CredoNaming.Check.Consistency.ModuleFilename.valid_filename?/3","doc":"Returns whether the filename matches the module defined in it.","ref":"CredoNaming.Check.Consistency.ModuleFilename.html#valid_filename?/3"},{"type":"behaviour","title":"CredoNaming.Check.Consistency.ModuleFilename.Plugins","doc":"","ref":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.html"},{"type":"function","title":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.module_for_name/1","doc":"","ref":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.html#module_for_name/1"},{"type":"callback","title":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.transform_paths/1","doc":"","ref":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.html#c:transform_paths/1"},{"type":"module","title":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.Phoenix","doc":"For Phoenix-specific filename consistency, the validator specifies two naming exceptions for the &quot;controller&quot; and &quot;view&quot; folders. This is needed because the folder structure is defined by something like &quot;/lib/app/controllers/my_controller&quot; while the expected controller module is &quot;App.MyController&quot;. In other words, the module definition doesn't expect the &quot;controller&quot; prefix from folder structure.","ref":"CredoNaming.Check.Consistency.ModuleFilename.Plugins.Phoenix.html"},{"type":"module","title":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames","doc":"This check has a base priority of low and works with any version of Elixir. Explanation In an effort to encourage more accurate module naming practices, it is sometimes useful to maintain a list of terms to avoid in module names. For example, if the list of terms to avoid is [&quot;Manager&quot;, &quot;Fetcher&quot;]: # preferred defmodule Accounts do end defmodule App.Networking do end # NOT preferred defmodule AccountManager do end defmodule App.DataFetcher do end Check-Specific Parameters Use the following parameters to configure this check: :terms A list of terms to avoid This parameter defaults to [] . General Parameters Like with all checks, general params can be applied. Parameters can be configured via the .credo.exs config file .","ref":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.html"},{"type":"function","title":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.traverse/4","doc":"","ref":"CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames.html#traverse/4"},{"type":"extras","title":"Changelog","doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [Unreleased]","doc":"","ref":"changelog.html#unreleased"},{"type":"extras","title":"Changelog - [2.1.0] - 2023-11-21","doc":"Add support for functions as CredoNaming.Check.Consistency.ModuleFilename plugins ( #28 ) Deprecate the use of :phoenix as a predefined plugin ( #29 )","ref":"changelog.html#2-1-0-2023-11-21"},{"type":"extras","title":"Changelog - [2.0.2] - 2023-10-03","doc":"Add app_paths option in CredoNaming.Check.Consistency.ModuleFilename to provide custom umbrella project apps path #27","ref":"changelog.html#2-0-2-2023-10-03"},{"type":"extras","title":"Changelog - [2.0.1] - 2022-10-20","doc":"Allow regular expressions in CredoNaming.Check.Consistency.ModuleFilename excluded paths #26","ref":"changelog.html#2-0-1-2022-10-20"},{"type":"extras","title":"Changelog - [2.0.0] - 2022-03-18","doc":"BREAKING: Filenames with dots ( . ) in them no longer considers dots as separators. For example, a FooWeb.Bar.Create module should be defined in lib/foo_web/bar/create.ex or lib/foo_web/bar/create/create.ex . lib/foo_web/bar.create.ex is no longer valid for this module. CredoNaming.Check.Consistency.ModuleFilename now supports a plugins list to enforce a specific file naming convention #17","ref":"changelog.html#2-0-0-2022-03-18"},{"type":"extras","title":"Changelog - [1.0.0] - 2020-10-06","doc":"Nothing new — just committing to a major version for semver benefits","ref":"changelog.html#1-0-0-2020-10-06"},{"type":"extras","title":"Changelog - [0.6.1] - 2020-05-08","doc":"Add missing changelog entries","ref":"changelog.html#0-6-1-2020-05-08"},{"type":"extras","title":"Changelog - [0.6.0] - 2020-05-07","doc":"Add Credo 1.4-specific features #12","ref":"changelog.html#0-6-0-2020-05-07"},{"type":"extras","title":"Changelog - [0.5.0] - 2020-03-12","doc":"Add support for a “valid_filename_callback” option ModuleFilename check #8","ref":"changelog.html#0-5-0-2020-03-12"},{"type":"extras","title":"Changelog - [0.4.1] - 2019-10-24","doc":"Exclude stdin source files for ModuleFilename (because we cannot check consistency between module and filename when we have no filename)","ref":"changelog.html#0-4-1-2019-10-24"},{"type":"extras","title":"Changelog - [0.4.0] - 2019-07-31","doc":"Add regex term support in AvoidSpecificTermsInModuleNames check","ref":"changelog.html#0-4-0-2019-07-31"},{"type":"extras","title":"Changelog - [0.3.1] - 2019-06-19","doc":"Improve documentation","ref":"changelog.html#0-3-1-2019-06-19"},{"type":"extras","title":"Changelog - [0.3.0] - 2019-06-18","doc":"Add AvoidSpecificTermsInModuleNames check","ref":"changelog.html#0-3-0-2019-06-18"},{"type":"extras","title":"Changelog - [0.2.1] - 2019-05-03","doc":"Added Add checking of protocol module filenames by @liskin . #2","ref":"changelog.html#0-2-1-2019-05-03"},{"type":"extras","title":"Changelog - [0.2.0] - 2019-04-26","doc":"Added Add support for umbrella projects by @liskin . #1","ref":"changelog.html#0-2-0-2019-04-26"},{"type":"extras","title":"README","doc":"CredoNaming is a suite of checks to enforce naming best practices in an Elixir project.","ref":"readme.html"},{"type":"extras","title":"README - Installation","doc":"Add the :credo_naming package to your mix.exs dependencies: def deps do [ { :credo_naming , &quot;~&gt; 2.0&quot; , only : [ :dev , :test ] , runtime : false } ] end","ref":"readme.html#installation"},{"type":"extras","title":"README - Usage","doc":"You just need to add the checks you want in your .credo.exs configuration file. Avoid specific terms in module names This check will raise an issue if specific terms are found in module names. { CredoNaming.Check.Warning.AvoidSpecificTermsInModuleNames , terms : [ &quot;Manager&quot; , ~r/Helpers?/ ] } Suppose you have a MyApp.ErrorHelpers module: $ mix credo ┃ Warnings - please take a look ┃ ┃ [W] ↘ `Helpers` is included in the list of terms to avoid in module names. ┃ Consider replacing it with a more accurate one. ┃ lib/my_app/error_helpers.ex:1:39 #(MyApp.ErrorHelpers) With this check configuration for example, a module named MyApp.UserManager or MyApp.FormHelpers would not be allowed. Ensure module/filename consistency This check will raise an issue if the name of a module defined in a file does not match its filename. { CredoNaming.Check.Consistency.ModuleFilename } Suppose you have a lib/foo.ex file that defines a Bar module: $ mix credo ┃ Consistency ┃ ┃ [C] ↘ The module defined in `lib/foo.ex` is not named consistently with the ┃ filename. The file should be named either: ┃ ┃ [&quot;lib/bar/bar.ex&quot;, &quot;lib/bar.ex&quot;] ┃ ┃ lib/foo.ex:1:11 #(Bar) Exclusions You can exclude files or paths with the excluded_paths option: { CredoNaming.Check.Consistency.ModuleFilename , excluded_paths : [ &quot;test/support&quot; , &quot;priv&quot; , &quot;rel&quot; , &quot;mix.exs&quot; ] } You can also exclude files or paths with regex: { CredoNaming.Check.Consistency.ModuleFilename , excluded_paths : [ ~r/test \\/ support/ , ~r/priv/ , ~r/.exs/ ] } Acronyms The check converts module names to paths using PascalCase convention, which means that the file lib/myapp_graphql.ex is expected to define the module: defmodule MyappGraphql do end If you want to define your own acronyms, you can do so using the acronyms option: { CredoNaming.Check.Consistency.ModuleFilename , acronyms : [ { &quot;MyAppGraphQL&quot; , &quot;myapp_graphql&quot; } ] } Using this, the lib/myapp_graphql.ex file will expect to define the module: defmodule MyAppGraphQL do end Naming conventions By default, the check allows for a specific list of valid filenames when a single module is declared within a file. You can overwrite this behaviour by providing the valid_filename_callback option and implement yourself if a filename should be considered valid. The callback receives three arguments: filename , the stringified name of the module contained in the file (eg. &quot;lib/my_app/foo/bar.ex&quot; ) module_name , the stringified name of the module contained in the file (eg. &quot;MyApp.Foo.Bar&quot; ) opts , the options list passed to the check (eg. [acronyms: [{&quot;GraphQL&quot;, &quot;graphql&quot;}]] ) And must return a tuple containing a boolean value (if the filename is considered valid) and a list of expected filenames. In this (very simple) example, a file lib/my_app/wrong.ex that defines a MyApp.Foo.Bar module would return a {false, [&quot;lib/my_app/foo/bar.ex&quot;]} tuple. def valid_filename? ( filename , module_name , _opts ) do root_path = CredoNaming.Check.Consistency.ModuleFilename . root_path ( filename ) path = &quot; \#{ Macro . underscore ( module_name ) } \#{ Path . extname ( filename ) } &quot; filenames = [ Path . join ( [ root_path , path ] ) ] { filename in filenames , filenames } end { CredoNaming.Check.Consistency.ModuleFilename , valid_filename_callback : &amp; valid_filename / 3 } You could also use the callback to ignore specific files and fallback on the default callback for others. def valid_filename? ( &quot;lib/my_app/my_specific_file.ex&quot; , _module_name , _opts ) , do : { true , [ ] } def valid_filename? ( &quot;lib/my_app/my_other_specific_file.ex&quot; , _module_name , _opts ) , do : { true , [ ] } def valid_filename? ( filename , module_name , opts ) , do : CredoNaming.Check.Consistency.ModuleFilename . valid_filename? ( filename , module_name , opts ) { CredoNaming.Check.Consistency.ModuleFilename , valid_filename_callback : &amp; valid_filename / 3 } Instead of implementing your own valid_filename_callback function, you can use the plugins option to enforce a specific supported naming convention. This option accepts a list of: one arity function or plugin name (for now, only CredoNaming.Check.Consistency.ModuleFilename.Plugins.Phoenix is supported as a predefined plugin). { CredoNaming.Check.Consistency.ModuleFilename , plugins : [ CredoNaming.Check.Consistency.ModuleFilename.Plugins.Phoenix , &amp; IO . inspect / 1 ] } Setting apps_path In case you have an umbrella project and have set apps_path to something other than apps , you can set the apps_path option to the correct path. { CredoNaming.Check.Consistency.ModuleFilename , apps_path : &quot;my_apps_path&quot; }","ref":"readme.html#usage"},{"type":"extras","title":"README - Contributors","doc":"Rémi Prévost ( @remiprev ) Tomáš Janoušek ( @liskin ) Felipe Duzzi ( @duzzifelipe ) Daniel Willeitner ( @D-Town44 ) Daniel Reigada ( @DReigada ) Pavel Tsiukhtsiayeu ( @paveltyk )","ref":"readme.html#contributors"},{"type":"extras","title":"README - License","doc":"CredoNaming is © 2019 Mirego and may be freely distributed under the New BSD license . See the LICENSE.md file. The tag logo is based on this lovely icon by Vectors Point , from The Noun Project. Used under a Creative Commons BY 3.0 license.","ref":"readme.html#license"},{"type":"extras","title":"README - About Mirego","doc":"Mirego is a team of passionate people who believe that work is a place where you can innovate and have fun. We’re a team of talented people who imagine and build beautiful Web and mobile applications. We come together to share ideas and change the world . We also love open-source software and we try to give back to the community as much as we can.","ref":"readme.html#about-mirego"}]